; =========================================================================

    .686P                       ; processor model
    .MODEL FLAT, STDCALL        ; memory model & calling convention
    OPTION CASEMAP :NONE        ; case sensitive

  ; Author Jake Commander
  ; Copyright The GeneSys Development System

    .code

; =========================================================================

align 4

copymem proc lpSource:DWORD,lpDest:DWORD,bcount:DWORD

    push    esi
    push    edi
    cld                         ; clear direction flag
    mov     esi, lpSource       ; source address in ESI
    mov     edi, lpDest         ; destination address in EDI
    mov     ecx, bcount         ; byte count to copy in ECX
    shr     ecx, 2              ; divide count by 4
    rep     movsd               ; copy DWORD size blocks
    mov     ecx, bcount         ; reload byte count
    and     ecx, 3              ; calculate remainder
    rep     movsb               ; copy tail
    pop     edi
    pop     esi

    ret

copymem endp

; =========================================================================

end
