; =========================================================================

    .686P                   ; processor model
    .MODEL FLAT, STDCALL    ; memory model and calling convention
    OPTION CASEMAP :NONE    ; case sensitive

  ; this algorithm was designed by Agner Fog
  ; slightly modified by Jake Commander.

    StrLen PROTO :DWORD

    .code

; =========================================================================

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 4

StrLen proc item:DWORD

    mov     eax, [esp+4]            ; get pointer to string
    push    ebx
    push    esi
    lea     edx, [eax+3]            ; pointer+3 used in the end
    mov     esi, 80808080h
  @@:     
    mov     ebx, [eax]              ; read first 4 bytes
    add     eax, 4                  ; increment pointer
    lea     ecx, [ebx-01010101h]    ; subtract 1 from each byte
    not     ebx                     ; invert all bytes
    and     ecx, ebx                ; and these two
    and     ecx, esi
    jz      @B                      ; no zero bytes, continue loop

    test    ecx, 00008080h          ; test first two bytes
    jnz     @F
    shr     ecx, 16                 ; not in the first 2 bytes
    add     eax, 2
  @@:
    shl     cl, 1                   ; use carry flag to avoid branch
    sbb     eax, edx                ; compute length
    pop     esi
    pop     ebx

    ret     4

StrLen endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; =========================================================================

end